clear all;
close all;
clc;



%Specify filename here to save
FILE_NAME = 'Obstacle_config006';

%Specify Epsilon which is distance b/w consecutive point obstacles
%generated by dividing the objects into number of points larger the value
%of Epsilon smoother the output will be but more computation time it will
%take. Decent value of Epsilon is 1
Epsilon = 1;

%Specify Total number of obstacle here
Num_Object=3;






%Main code starts here
handle = figure;
axis([0 100 0 100]);
hold on;

X_Total_points=0;
Y_Total_points=0;
All_cells_Number=0;
Cell_start=1;

for i=1:Num_Object
   X1{i} = ginput;
   X2{i} = circshift(X1{i},1);    %shifting to calculate rms edge length
l = sqrt(sum(((X2{i}-X1{i}).*(X2{i}-X1{i}))'));   %rms edge length
Num_points = floor(l/Epsilon);

size_input =  length(X1{i});
X_points{i}=0;
Y_points{i}=0;

for j=1:size_input
        %points on one edge of obstacle 
        X_edge{i}{j}=X1{i}(j,1):(X2{i}(j,1)-X1{i}(j,1))/Num_points(j):X2{i}(j,1);
        
        Y_edge{i}{j}=X1{i}(j,2):(X2{i}(j,2)-X1{i}(j,2))/Num_points(j):X2{i}(j,2);
        plot(X_edge{i}{j},Y_edge{i}{j});
        X_edge{i}{j}(1)=[]; %removing first element to avoid repetetion
        Y_edge{i}{j}(1)=[]; %removing first element to avoid repetetion
        
        %Total points on an obstacle
        X_points{i}=cat(2,X_points{i},X_edge{i}{j});
        Y_points{i}=cat(2,Y_points{i},Y_edge{i}{j});
        
        
end

   for r=1:size_input
       a=r;
       if(r==size_input)
           b=1;
       else
           b=r+1;
       end
           
       plot(X1{i}(a:b,1),X1{i}(a:b,2));
       hold on;
       drawnow;
   end

X_points{i}(1)=[];
Y_points{i}(1)=[];
Cell_Number{i} = i*ones(size(X_points{i}));

%Total points 
X_Total_points=cat(2,X_Total_points,X_points{i});
Y_Total_points=cat(2,Y_Total_points,Y_points{i});
All_cells_Number = cat(2,All_cells_Number,Cell_Number{i});
Cell_start(i+1) = length(All_cells_Number)+1;
%drawnow;
end

X_Total_points(1)=[];
Y_Total_points(1)=[];
All_cells_Number(1)=[];
%saves the figure 
saveas(handle,strcat('./Obstacle_Files/',FILE_NAME,'.jpg'));
%Stores the drawn obstacle in file with the same name as figure
save(strcat('./Obstacle_Files/',FILE_NAME));



